program NkCal;

{$IMPORTEDDATA OFF}
{$R *.RES}

uses NLib, NSys, NApp, NForm, NConf, NResource, MainForm;

type
  TNkCalApp = class(TApp)
    procedure Init; override;
    destructor Destroy; override;
  end;

procedure TNkCalApp.Init;
var
  keymap: TConf;
begin
  ProfDir := GetEnv('NKTOOLSPROF');
  if ProfDir = '' then
    ProfDir := DirName(ProgPath)
  else
    ProfDir := JoinPath([ProfDir, 'nkcal']);

  Config := TConf.Create;
  Config.Read(ResourceText('CONFIG'));
  Config.LoadFromFile(JoinPath([ProfDir, 'position']));
  Config.LoadFromFile(JoinPath([ProfDir, 'config']));

  keymap := TConf.Create;
  keymap.Read(ResourceText('KEYMAP'));
  keymap.LoadFromFile(JoinPath([ProfDir, 'keymap']));

  MainForm := TNkCalMainForm.Create;
  with MainForm as TNkCalMainForm do begin
    Command.BindKeys(keymap);
    keymap.Free;
    Accel := Command.AccelHandle;
  end;

  Run;
end;

destructor TNkCalApp.Destroy;
begin
  MainForm.Free;
  Config.Free;
end;

begin
  App := TNkCalApp.Create('NkCal');
  try
    try
      App.Init;
    except
      App.Fatal;
    end;
  finally
    App.Free;
  end;
end.
